% diagraphiefigcallback
%
% Fichier des callcbacks des lments d'interface graphique de diagchoix.fig
% C'est donc lui qui gre les actions gnrs quand on slectionne
% un lment de la figure cre quand on lance le script 'diagraphiefig'
%
%******************************************************************************
% Elements de programmation
% @ Fichiers associes
%    diagraphiefig.fig, diagraphiefig.m  => Fentre d'interface graphique.
%    selectrange, selectrange.fig     => slection par valeur des
%                                        signaux d'lectrodes 
%    selectprof, selectprof.fig       => Slection par profondeur ou bloc.
%    profcorrect, coupe               => Corrige et coupe la
%                                        matrice des profondeurs 
%    imaging.m                        => Affiche les diagraphies
% @ Liste des lments et des callbacks appels dans l'ondre des
% lments graphique 
% - Frame 'Nom du fichier'
%      - Case d'dition
%         'ButtonDownFcn' (quand on clique dessus avec le bouton DROIT)
%             => diagraphiefigcallback('fileselect')
%                 Essentiellement lance la procdure d'ouverture.
%         'Callback' (quand on clique dessus avec le bouton gauche,
%         et que l'on dite) 
%             => diagraphiefigcallback('filename')
% - Frame 'sans titre'
%     Quand on clique dessus, les callbacks sont modifis et passent en mode 
%     'dslection'. 
%      - Radiobutton 'brut'
%             => diagraphiefigcallback('brut')
%      - Radiobutton 'grad'
%             => diagraphiefigcallback('grad')
%      - Radiobutton 'orient'
%             Ce bouton est tout d'abord invisible
%             => diagraphiefigcallback('oriente')
%                On ne fait que vrifier que les donnes sont correctes sinon 
%      - Radiobutton 'corrig'
%             => diagraphiefigcallback('corrige')
%                Il corrige les profondeurs des drives cres par
%                un bug du programme de Wileveau 
%      - Radiobutton 'coup'
%             => diagraphiefigcallback('coupe')
%                 Pratiquement rien n'est fait quand on clique dessus.
%                 les champs profondeurs et blocs sont griss car ils 
%                    ne seront pas utiliss
%                 et on ne coupe qu'au moment de lancer la diagraphie
% 

% @ Liste des callback
%  Ils sont sous la forme  diagraphiefigcallback(selection,option)
%  Option est optionnel !
% A l'heure actuelle (bientt le repas !), ce script fait plus de
% 1000 lignes. Pour pouvoir accder rapidement au callback
% intressant, des chaine de caractres ont t places au dbut de
% chaque callback en commentaire. Elles sont uniques dans le  
% fichier, et donc une recherche de ces chaines de caractres
% (CRTL-F) amne directement au callback voulu. Dans la description
% suivante, ces chaines se trouvent sous le  vocable 'cl'
% La cl de cette liste est 'miaou' (=> trouvable par 'Rechercher' 'miaou')
%  Diffrentes slections sont possibles, dont la liste, dans
%  l'ordre de ce script est : 
%  - 'diagraphie' : lancement de la diagraphie, en tenant compte
%                    des choix effectus 
%                   Bouton 'Diagraphie'
%                   Cl  : aaaa
%  - 'annuler'    : ferme la fentre
%                   Bouton 'Annuler'
%                   Cl  : bbbb
%  - 'set'        : stocke les donnes quand elles semblent
%                   correctes. Plusieurs types de donnes sont
%                   possibles, et il faut en prciser le type  
%                   par l' 'option' :
%                       - 'data'   : collecte des donnes  diagrapher
%                       - 'prof'   : On stocke les profondeurs
%                       - 'offset' : On actualise les profondeurs montres
%                   Ce code est en fait appel par d'autres Callbacks
%                   Cl  : cccc
%  - 'reset'      : dstocke les donnes. Plusieurs 
%                   type de donnes sont possible, et il faut en
%                   prciser le type  
%                   par l' 'option' :
%                       - 'data' : donnes  diagrapher
%                       - 'prof' : profondeurs
%                   Ce code est en fait appel par d'autres Callbacks
%                    Cl  : dddd
%  - 'guide'      : Pour aider l'utilisateur  naviguer au mileu de
%                   toutes les frames l'interface graphique volue
%                   de manire  montrer les lments  
%                   de slection importants, prciss par 'option' :
%                       - 'initation russie' : 
%                       - 'manuel'
%                       - 'data selection'
%                       - 'prof selection'
%                       - 'pret'
%                       - 'orientable'
%                       - 'non orientable'
%                       - 'coupe'
%                       - 'non coupe'
%                   Ce code est en fait appel par d'autres Callbacks
%                    Cl  : eeee
%  - 'fileselect' : On slectionne le fichier de manire interactive
%                    Clic DROIT dans la case d'dition 'Nom de fichier'
%                    Cl  : ffff
%  - 'fileselect' : On dite le fichier de manire interactive. 
%                    Clic GAUCHE dans la case d'dition 'Nom de fichier'
%                    Cl  : gggg
%  - 'file'       : On traite le fichier dsir et on  
%                    Appel par diagraphiefigcallback('fileselect') 
%                            ou diagraphiefigcallback('filename')
%                    Cl  : hhhh
%  - 'brut'
%                    Radiobutton 'brut' quand on slectionne
%                    Cl  : iiii
%  - 'no brut'
%                    Radiobutton 'brut' quand on dselectionne 
%  - 'grad'
%                    Radiobutton 'grad' quand on slectionne
%                    Cl  : jjjj
%  - 'no grad'
%                    Radiobutton 'grad' quand on dselectionne 
%  - 'oriente'
%                    Checkbox 'oriente' quand on slectionne
%                    Cl  : kkkk
%  - 'non oriente'
%                    Checkbox 'oriente' quand on dslectionne
%  - 'coupe'
%                    Checkbox 'coupe' quand on slectionne
%                    Cl  : llll
%  - 'non coupe'
%                    Checkbox 'coupe' quand on dslectionne
%  - 'corrige'
%                    Cl  : mmmm
%  - 'non corrige'
%  - 'explorefile'
%                    Pushbutton 'Explorer le fichier' du frame 'Donnes'
%                    Cl  : nnnn
%  - 'workspace'
%                    Cl  : oooo
%  - 'nom'
%                    Cl  : pppp
%  - 'explorefileprof'
%                    Cl  : qqqq
%  - 'workspaceprof'
%                    Cl  : rrrr
%  - 'nomprof'
%                    Cl  : ssss
%  - 'offset'
%                    Clic GAUCHE dans la case d'dition 'Offset Profondeur'
%                    Cl  : tttt
%  - 'selectrange'
%                    Cl  : uuuu
%  - 'colormap'
%                    Cl  : vvvv
%  - 'editcolormap'
%                    Cl  : wwww
%  - 'debut'
%                    Cl  : xxxx
%  - 'fin'
%  - 'selectbloc'
%  - 'pmin'
%                    Cl  : yyyy
%  - 'pmax'
%  - 'selectprof'
%
% @ Visibilit des codes;
% Certains codes demandent  explorer le workspace courant au moment
% o l'application est lance. Or, les paramtres d'une fonction sont
% passs par valeurs, et un nouvel espace de travail (workspace) est
% cr au moment du lancement de la fonction. On n'a alors pas accs
% au callback courant.  La parade consiste  copier le bout de code
% correspondant au script excut par une interface graphique dans le
% champ 'Callback' de cet lment. Cela se fait aisment  l'aide de
% 'guide', l'aide  l'interface graphique.
% CONSEQUENCE : Lorsqu'on fait une modification sur une telle
% squence, il vaut mieux le faire d'abord dans ce fichier o
% l'dition est facile, et le copier-coller dans le 'Callback' de
% cet lment. Cela se fait aisment  l'aide de 'guide', l'aide 
% l'interface graphique de Matlab. 
% 
% Les lments concerns sont :
%   Dans le frame 'donnes'
%      - 'Explorer le fichier' => diagraphiefigcallback('explorefile')
%      - La case d'edition     => diagraphiefigcallback('nom')
%   Dans le frame 'Profondeur'
%      - 'Explorer le fichier' => diagraphiefigcallback('explorefileprof')
%      - La case d'edition     => diagraphiefigcallback('nomprof')
%   Dans le frame 'Offset Profondeur'
%      - La case d'edition     => diagraphiefigcallback('offset')
%
% @ Destine des donnes
% - donne lectrique
%      Elle est a priori stocke dans un fichier. La case
%      'selection du fichier' est bien mise en vidence. Si on
%      slectinne le fichier, le programme stocke. Si toutes les
%      donnes ncessaires  la diagraphie sont obtenables, on
%      passe au choix des paramtres. La ligne ncessaire au bon
%      choix y est stocke. 
%    APPDATA correspondantes :  
%	data 				Donne, au besoin gradients
%	databrut			Cre quand on calcule le gradient,
%					pour stocker la valeur initiale
%	datagrad			Cre quand on revient au brut
%					pour stocker le valeur gradient
%       couronne            Dans le cas des fichiers issus de .fht ou .fra
% - l'orientation n'est gre qu'  la fin du programme.
% - le gradient est par contre au besoin calcul au cours du progamme afin de 
% pouvoir rudier ses valeurs
% -la correction des profondeurs est effectue ds son appel
% puisqu'elle affecte la gestion des prfondeurs
% - Si l'offset est non nul, on garde  part la donne brute,
% ventuellement corrige et l'offset. On recalcule la somme  chaque fois.
%    APPDATA         PROF          	Profondeur eventuellement corrige
%   		     PROFbrut           Cr quand on corrige les profondeurs, 
%					 pour stocker la valeur initiale
%		     PROFoffset		Cr quand on choisit une slection
% Gestion de l'orientation
%  APPDATA			
%    delta			Rotation	propre de la matrice
%    autooriente  Si il existe rechercher dans le fichier les donnes
%
%
%

function diagraphiefigcallback(selection,option)
switch selection
   % selection appelle plusieurs sous procdures :
   % diagraphie l. 25, annuler l.66
   % explorefile workspace 
   % range filename 
   % nofile
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    Actions     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   %% Boutons Actions : diagraphie, annuler   
case 'diagraphie'   % Callback du bouton diagraphie
   % aaaa
   filestring=get(findobj(gcbf,'Tag','filename'),'string');
   %  On rcupre les donnes
   %     - lectriques
   if isappdata(gcbf,'data')
      data=getappdata(gcbf,'data');
      if ndims(data)>2
         couronne=get(findobj(gcbf,'tag','couronne'),'Value');
         data=data(:,:,couronne);
         polycouronne=1;
      else
         polycouronne=0;            
      end
   else
      h=warndlg(['Pas de matrice de donnes rentre. '... 
            'La visualisation est impossible'],...
         'Visualisation impossible');
      return;
   end
   % Orientation 
   brutok=get(findobj(gcbf,'tag','brut'),'value');
   nordok=get(findobj(gcbf,'tag','nord'),'value');
   hautok=get(findobj(gcbf,'tag','haut'),'value');  
   if ~brutok & ~nordok & ~hautok
      brutok=1;
   end
   if brutok
      gradok=get(findobj(gcbf,'tag','grad'),'value');	
      if gradok
         [no,data]=gradient(data);	
      end
    end
   if hautok                                 
      pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
      file=[pathname filestring];
      if ~isempty(filestring)    
		   feval('load',file);
         gradok=get(findobj(gcbf,'tag','grad'),'value');		          
         if ~gradok                          
            hautstring=who('-file',file,'LOGGhaut');
            data=eval(hautstring{1});
         else
            hautgradstring=who('-file',file,'GRADhaut');
            if isempty(hautgradstring)
			      hautstring=who('-file',file,'LOGGhaut');
               hautdata=eval(hautstring{1});
               [no,data]=gradient(hautdata);
            else
               data=eval(hautgradstring{1});
            end
         end
      end
   end
   if nordok                                 
      pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
      file=[pathname filestring];
      if ~isempty(filestring)    
		   feval('load',file);
         gradok=get(findobj(gcbf,'tag','grad'),'value');		          
         if ~gradok                          
            nordstring=who('-file',file,'LOGGnord');
            data=eval(nordstring{1});
         else
            nordgradstring=who('-file',file,'GRADnord');
            if isempty(nordgradstring)
               nordstring=who('-file',file,'LOGGnord');
               norddata=eval(nordstring{1});
               [no,data]=gradient(norddata);
            else
               data=eval(nordgradstring{1});
            end
         end
      end
   end
   % profondeur
   stackok=get(findobj(gcbf,'tag','stack'),'value');
   if isappdata(gcbf,'prof')
      prof=getappdata(gcbf,'prof');
      if isappdata(gcbf,'offset')
         offset=getappdata(gcbf,'offset');
         prof=prof+offset;
      end
   else
      % Au pire, toujours diagrapher avec les blocs.
      answer=questdlg(['Pas de bonnes de profondeur entre.'...
            'Doit-on prendre les indices de blocs  la place ?'],...
         'Donnes non nulles',...
         'Allons-y',...
         'Revoir la copie','Allons-y');
      switch answer
      case 'Allons-y'
         prof=[1:size(data,1)];
         stackok=0;
      case 'Revoir la copie'
         return
      end
   end
   if stackok
      pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
      file=[pathname filestring];
      if ~isempty(filestring)    
		   feval('load',file);
         gradok=get(findobj(gcbf,'tag','grad'),'value');		          
         if ~gradok                          
            stackstring=who('-file',file,'LOGGstack');
            data=eval(stackstring{1});
         else
            nordstackstring=who('-file',file,'GRADstack');
            if isempty(nordstackstring)
               stackstring=who('-file',file,'LOGGstack');
               stackdata=eval(stackstring{1});
               [no,data]=gradient(stackdata);
            else
               data=eval(nordstackstring{1});
            end
         end
      else
         warndlg('Comme le calcul du stack est long, mieux vaut le calculer une fois pour toute.')
         return;
      end
   end      
   % Apres toutes ces manips on se ramne  la bonne couronne le cas chant
      if ndims(data)>2
         couronne=get(findobj(gcbf,'tag','couronne'),'Value');
         data=data(:,:,couronne);
         polycouronne=1;
      else
         polycouronne=0;            
      end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Eventail des valeurs observes
   cmin=str2num(get(findobj(gcbf,'Tag','vmin'),'string')); 
   cmax=str2num(get(findobj(gcbf,'Tag','vmax'),'string')); 
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Indices des blocs observs
   vmin=str2num(get(findobj(gcbf,'Tag','debut'),'string')); 
   vmax=str2num(get(findobj(gcbf,'Tag','fin'),'string'));
   % Si on coupe
   coupeok=get(findobj(gcbf,'Tag','coupe'),'value');
   if coupeok
      [data,prof,vmax]=coupe(data,prof);
      vmin=1;
   end   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Colormap
   map=colormap;
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Titre automatique
   loggok=get(findobj(gcbf,'Tag','brut'),'value');
   if loggok~=0
      brut=' : image lectrique brute ';
   else 
      brut=' ';
   end
   oriente='';
   hautok=get(findobj(gcbf,'Tag','haut'),'value');
   if hautok~=0
      oriente=' oriente selon la gnratrice haute du forage ';
   end
   nordok=get(findobj(gcbf,'Tag','nord'),'value');
   if nordok~=0
      oriente=' oriente vers le nord ';
   end     
   if polycouronne==1
      couronnestring=[' -- Couronne ' num2str(couronne)];
   else
      couronnestring='';
   end
   % Pour modifier les orientations du forage, on peut avoir
   % besoin du fichier d'origine (utile pour sinusoide)
   pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
   file=[pathname filestring];
   % On te ventuellement la disgracieuse extension du titre
   if ~isempty(filestring)   
      if filestring(length(filestring)-3)=='.'
         filestring=[filestring(1:length(filestring)-4)];
      end
   else
      filestring=' ';
   end
   titre=[ 'diagraphie ' filestring oriente brut couronnestring];
   disp(titre)
   % ENFIN ON AFFICHE LES FIGURES DE DIAGRAPHIE
   % Go !
   if isappdata(gcbf,'orientation')
      orientation=getappdata(gcbf,'orientation');
      fig=feval('imaging',data,prof,...
         [ cmin cmax], [vmin vmax],map,titre,file,orientation); 
   else
      fig=feval('imaging',data,prof,...
         [ cmin cmax], [vmin vmax],map,titre,file); 
   end
   % UNE FOIS LES FIGURES TRACEES ON PEUT LES NOMMER
   coupeok=get(findobj(gcbf,'Tag','coupe'),'value');
   if coupeok
      coupe=' coupe ';
   else
      coupe='';
   end
  if hautok~=0
      oriente=' haut ';
   end
   nordok=get(findobj(gcbf,'Tag','nord'),'value');
   if nordok~=0
      oriente=' nord ';
   end     

   name=['diagraphie ' filestring coupe oriente];
   set(fig,'name',name);
   %   set(gcbf,'name');
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'annuler'
   % bbbb
   close(gcbf);
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    Donnes     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   %%% Donnes de diagraphies
   % &e tapes : fichiers
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Initialisation des cadres (frames) 'Valeurs' et 'bloc'
case 'set'
   % cccc
   switch option
   case 'data'
      data=getappdata(gcbf,'data');
      if ndims(data)>2
         set(findobj(gcbf,'tag','couronne'),'Visible','on');
         couronne=get(findobj(gcbf,'tag','couronne'),'Value');            
         data=data(:,:,couronne);
      end
      cmin=min(data(:));     
      set(findobj(gcbf,'Tag','cmin'),'string',num2str(cmin));
      set(findobj(gcbf,'Tag','vmin'),'string',num2str(cmin));
      cmax=max(data(:));
      set(findobj(gcbf,'Tag','cmax'),'string',num2str(cmax));
      set(findobj(gcbf,'Tag','vmax'),'string',num2str(cmax));
      blocs=size(data,1);
      set(findobj(gcbf,'Tag','debut'),'String',num2str(1)); 
      set(findobj(gcbf,'Tag','fin'),'String',num2str(blocs) ); 
      set(findobj(gcbf,'Tag','taille'),'String',num2str(blocs));
      % Initialisation du cadre (frame) 'Profondeur'
   case 'prof'
      prof=getappdata(gcbf,'prof');
      if isappdata(gcbf,'offset')
         offset=getappdata(gcbf,'offset');
         prof=prof+offset;
      end
      pmin=min(prof);
      pmax=max(prof);
      set(findobj(gcbf,'Tag','pmin'),'String',num2str(pmin));
      set(findobj(gcbf,'Tag','pmax'),'string',num2str(pmax));
   end
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'reset'
   % dddd
   switch option
   case 'data'
      if isappdata(gcbf,'data')
         rmappdata(gcbf,'data')
      end
      if isappdata(gcbf,'databrut');
         rmappdata(gcbf,'databrut');
      end
      if isappdata(gcbf,'datagrad')
         rmappdata(gcbf,'datagrad');
      end
   case 'prof'
      if isappdata(gcbf,'prof')
         rmappdata(gcbf,'prof');
      end
      if isappdata(gcbf,'profbrut')
         rmappdata(gcbf,'profbrut');
      end
      set(findobj(gcbf,'Tag','profoffset'),'Userdata',[])
   case 'oriente'
      if isappdata(gcbf,'delta')
         rmappdata(gcbf,'delta');
      end
      if isappdata(gcbf,'autooriente')
         rmappdata(gcbf,'autooriente');
      end
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'guide'
   % eeee
   % suivi de l'volution de l'interace graphique quand on avance
   % dans la slection 
   grisclair=[ 0.752941176470588 ...
         0.752941176470588 ...
         0.752941176470588 ];   % normal 
   jauneclair=[ 0.992156862745098 ...
         0.952941176470588 ...
         0.509803921568627];% selection 
   gris=[ 0.501960784313725 ....
         0.501960784313725 ....
         0.501960784313725 ];% inactiv
   blanc=[1 1 1];
   switch option
      % La couleur jaune du cadre 'file' disparait.
      % La case de slection apparait
   case 'initiation russie'
      % Le fichier a t correctement lu, rien ne manque
      % L'obtention du fichier est finie => Couleurs normales pour
      % le cadre 'Nom du fichier' 
      % A -Checkbox du cadre de slection convenable
      %Valeur par dfaut
      set(findobj(gcbf,'tag','brut'),'value',1);
      set(findobj(gcbf,'tag','haut'),'value',0);
      set(findobj(gcbf,'tag','nord'),'value',0);
      set(findobj(gcbf,'tag','stack'),'value',0);
      set(findobj(gcbf,'tag','grad'),'value',0);
      set(findobj(gcbf,'tag','coupe'),'value',0,'Callback','diagraphiefigcallback(''coupe'')');
      % Retour   la normale pour le cadre du choix du fichier
      set(findobj(gcbf,'Userdata','file'),'BackgroundColor',grisclair);
      set(findobj(gcbf,'tag','filename'),'BackgroundColor',grisclair);
      % On met en viddence la prochaine tape : slection,
      set(findobj(gcbf,'Userdata','selection'),'BackgroundColor',jauneclair);
      set(findobj(gcbf,'Tag','diagraphie'),'BackgroundColor',jauneclair);
      % on grise les fentres d'dition des profondeurs et des donnes
      % On signale l'origine des paramtres
      filename=get(findobj(gcbf,'tag','filename'),'string');
      set(findobj(gcbf,'Tag','dataname'),'BackgroundColor',grisclair,...
         'string',filename);
      set(findobj(gcbf,'Tag','profname'),'BackgroundColor',grisclair,...
         'string',filename);
      % Paramtrage activ
      diagraphiefigcallback('guide','data selection');
      diagraphiefigcallback('guide','prof selection');
   case 'manuel'
      %Mode manuel
      % Tous les units sont en couleurs normales
      set(findobj(gcbf,'Userdata','file'),'BackgroundColor',grisclair);
      set(findobj(gcbf,'Userdata','selection'),'BackgroundColor',grisclair);
      set(findobj(gcbf,'Tag','diagraphie'),'BackgroundColor',jauneclair);
      set(findobj(gcbf,'tag','brut'),'value',0,....
         'Callback','diagraphiefigcallback(''brut'')');
      set(findobj(gcbf,'tag','grad'),'value',0,....
         'Callback','diagraphiefigcallback(''grad'')');
      set(findobj(gcbf,'tag','oriente'),'value',0);
      % Quand on pret, diagraphie passe en jaune
   case 'data selection'
      % Selection des Blocs active
      set(findobj(gcbf,'style','edit','tag','debut'),'BackgroundColor',blanc);
      set(findobj(gcbf,'style','edit','tag','fin'),'BackgroundColor',blanc);
      % Selection des Valeurs active
      set(findobj(gcbf,'style','edit','tag','vmin'),'BackgroundColor',blanc);
      set(findobj(gcbf,'style','edit','tag','vmax'),'BackgroundColor',blanc);
      % Selection de la colormap active
      set(findobj(gcbf,'style','edit','tag','colormap'),...
         'BackgroundColor',blanc);
   case 'prof selection'
      % Selection des Profondeurs active
      set(findobj(gcbf,'style','edit','tag','pmin'),'BackgroundColor',blanc);
      set(findobj(gcbf,'style','edit','tag','pmax'),'BackgroundColor',blanc);
      % Selection de ,l'Offset Profondeur active
      set(findobj(gcbf,'style','edit','tag','profoffset'),...
         'BackgroundColor',blanc)
   case 'pret'
      set(findobj(gcbf,'Userdata','file'),'BackgroundColor',grisclair);
      set(findobj(gcbf,'Userdata','selection'),'BackgroundColor',grisclair);
      set(findobj(gcbf,'Tag','diagraphie'),'BackgroundColor',jauneclair);
   case 'coupe'   
      % Quand on demande la coupe, empecher de selctionner blocs et couleurs
      set(findobj(gcbf,'userdata','bloc'),'BackgroundColor',gris);
      set(findobj(gcbf,'userdata','profondeur'),'BackgroundColor',gris);
      set(gcbo,'Callback','diagraphiefigcallback(''non coupe'')')
   case 'non coupe'
      % On refuse la coupe, retour  la normale
      set(findobj(gcbf,'userdata','bloc'),...
         'BackgroundColor',grisclair);
      set(findobj(gcbf,'userdata','bloc','tag','debut'),...
         'Backgroundcolor',blanc);
      set(findobj(gcbf,'userdata','bloc','tag','fin'),...
         'Backgroundcolor',blanc);      
      set(findobj(gcbf,'userdata','profondeur'),...
         'BackgroundColor',grisclair);
      set(findobj(gcbf,'style','edit','Tag','pmin'),...
         'BackgroundColor',blanc);
      set(findobj(gcbf,'style','edit','Tag','pmax'),...
         'BackgroundColor',blanc);      
      set(gcbo,'Callback','diagraphiefigcallback(''coupe'')')
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Si on clique sur avec le bouton droit : selection interactive
case 'fileselect'
   % ffff
   [filename, filepath ]=uigetfile('*.mat','Fichier  visualiser');
   if filename==0
      filename=[];
      filepath=[];
   end
   set(gcbo,'string',filename,'userdata',filepath);
   diagraphiefigcallback('file');
case 'filename'
   % gggg
   set(gcbo,'Userdata', '');
   diagraphiefigcallback('file');
   % Si on clique avec le bouton gauche : edition
case 'file'
   % hhhh
   % Reinitialisation des fichiers
   diagraphiefigcallback('reset','data');
   diagraphiefigcallback('reset','prof');
   diagraphiefigcallback('reset','oriente');
   % Callback de l'edition 'nom du fichier'
   filename=get(gcbo,'string');
   if isempty(filename)
      set(gcbo,'string',[]);
      return
   end
   if length(filename)>3
      if filename(length(filename)-3)=='.'
         extension=lower(filename([(length(filename)-2):length(filename)]));
         pathname=get(gcbo,'Userdata');
         % on verifie que le fichier a la bonne extension et on gre sinon
         if ~isequal(extension,'mat')
            disp('Ce programme prend en entre des fichiers .mat');
            disp('Utiliser le script htpf.m');
            set(findobj(gcf,'Tag','filename'),'string','');
            return;
         end
      end
   end
   
   % Rcupration des donnes
   %Recherche des donnees de base : profndeur brute, donnes brutes. 
   % pour cela on utilise deux procdues
   % - identifier les fichiers
   % - vrifier leur validit, et passer  la slection manuelle
   %%%%% Ideintifcation des fichiers
   % On verifie le contenu du fichier
   % POur cela : 1 - On liste les noms
   %             2-  Si il ya des absents ils e sontpas compts (cf
   %             help 'who.m') 
   %             3- On prned le premier de la liste.
   % 1- Enumration des noms possibles
   pathname=get(gcbo,'Userdata');
   feval('load',[pathname filename]);
   haut=who('-file',[pathname filename],'LOGGhaut');
   north=who('-file',[pathname filename],'LOGGnord');
   brut=who('-file',[pathname filename],'LOGGbrut');
   stack=who('-file',[pathname filename],'LOGGstack');
   prof=who('-file',[pathname filename],'PROFbrut','PROF');
   lambda=who('-file', [pathname filename],'lambda');
   gamma=who('-file', [pathname filename],'gamma');
   offset=who('-file',[pathname filename],'PROFoffset');
   brutok=~isempty(brut); 
   nordok=~isempty(north);
   hautok=~isempty(haut);
   profok=~isempty(prof);
   stackok=~isempty(stack);
   offsetok=~isempty(offset);
   orienteok=~isempty(gamma)&~isempty(lambda);
   allok=1; % tout est ok ?
   % Test des donnes
   if brutok
      setappdata(gcbf,'data',eval(brut{1}));
      if ndims(brut{1})>2
         s=strvcat('1','2','3','4','5','6','7','8','9','10');
         set(findobj(gcbf,'Tag','couronne'),'visible', 'on','string',s);
      else
         set(findobj(gcbf,'Tag','couronne'),'visible', 'off');
      end
   else
      h=warndlg(['Il n''y a apparemment pas de matrices de donnes '...
            'dans ce fichier. Explorer le fichier ou exploitez '...
            'le workspace pour vous en sortir'],...
         'Pas de matrice de donne apparente');
      allok=0;
   end
   if ~hautok;
      set(findobj(gcf,'Tag','haut'),'Value',0,'Visible','off');
   end
   if ~nordok;
      set(findobj(gcf,'Tag','nord'),'Value',0,'Visible','off');
   end
   if ~stackok;
      set(findobj(gcf,'Tag','stack'),'Value',0,'Visible','off');
   end
   
   % Test des profondeurs
   if profok
      setappdata(gcbf,'prof',eval(prof{1}));
      if offsetok
         setappdata(gcbf,'offset',PROFoffset);
         set(findobj(gcbf,'Tag','profoffset'),'string','PROFoffset',...
            'Userdata',num2str(PROFoffset));
      end
   else
      h=warndlg(['Il n''y a apparemment pas de matrice de profondeur '...
            'dans ce fichier. Explorer le fichier ou exploitez '...
            'le workspace pour vous en sortir'],...
         'Apparemment, pas de matrice de profondeur');
      allok=0;
   end
   % Pour sinsuoide on peut imposer l'orientation
   if orienteok
      feval('load',[pathname filename],'lambda');
      if iscell(lambda)
         setappdata(gcbf,'lambda',lambda{1});
      else
         setappdata(gcbf,'lambda',lambda);
      end
      if isstruct(lambda)
         setappdata(gcbf,'lambda',lambda.lambda);
      end
      feval('load',[pathname filename],'gamma');
      if iscell(gamma)
         setappdata(gcbf,'gamma',gamma{1});
      else
         setappdata(gcbf,'gamma',gamma);
      end
      if isstruct(gamma)
         setappdata(gcbf,'gamma',gamma.gamma);
      end
      orientation=[lambda gamma];
      setappdata(gcbf,'orientation',orientation);
   end
   % Si tout va bien, faire suivre le guide de lancement
   if allok
      diagraphiefigcallback('set','data');
      diagraphiefigcallback('set','prof');
      diagraphiefigcallback('guide','initiation russie');
   else
      % sinon au moins mettre en place les donnes et on ne guide
      % plus l'utilisateur 
      if loggok~=0
         diagraphiefigcallback('set','data');
         diagraphiefigcallback('guide','manuel');
      end
   end
   % Pour controle
   %getappdata(gcf)
case 'couronne'
   diagraphiefigcallback('set','data');
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%%%%%%   Frame 'selection'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'brut'
   set(findobj(gcf,'Tag','nord'),'value',0);
   set(findobj(gcf,'Tag','haut'),'value',0);   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'haut'
   set(findobj(gcf,'Tag','brut'),'value',0);
   set(findobj(gcf,'Tag','nord'),'value',0);    
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'nord'
   set(findobj(gcf,'Tag','haut'),'value',0);
   set(findobj(gcf,'Tag','brut'),'value',0);    
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'coupe'
   % llll
   diagraphiefigcallback('guide','coupe');
   % sera en fait gr par diagraphie
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'non coupe'
   diagraphiefigcallback('guide','non coupe');
   % sera en fait gr par 'diagraphie'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'grad'
   filestring=get(findobj(gcbf,'Tag','filename'),'string');
   %  On rcupre les donnes
   %     - lectriques
   if isappdata(gcbf,'data')
      data=getappdata(gcbf,'data');
      if ndims(data)>2
         couronne=get(findobj(gcbf,'tag','couronne'),'Value');
         data=data(:,:,couronne);
      end
   end
   % Orientation 
   brutok=get(findobj(gcbf,'tag','brut'),'value');
   nordok=get(findobj(gcbf,'tag','nord'),'value');
   hautok=get(findobj(gcbf,'tag','haut'),'value');  
   if ~brutok & ~nordok & ~hautok
      brutok=1;
   end
   if brutok
      [no,data]=gradient(data);	
      return;
   end
   if hautok                                 
      pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
      file=[pathname filestring];
      if ~isempty(filestring)    
         feval('load',file);
         hautgradstring=who('-file',file,'GRADhaut');
         if isempty(hautgradstring)
            hautstring=who('-file',file,'LOGGhaut');
            hautdata=eval(hautstring{1});
            [no,data]=gradient(hautdata);
         else
            data=eval(hautgradstring{1});
         end
      end
   end
   if nordok                                 
      pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
      file=[pathname filestring];
      if ~isempty(filestring)    
         feval('load',file);
         nordgradstring=who('-file',file,'GRADnord');
         if isempty(nordgradstring)
            nordstring=who('-file',file,'LOGGnord');
            norddata=eval(nordstring{1});
            [no,data]=gradient(norddata);
         else
            data=eval(nordgradstring{1});
         end
      end
   end 
   if isappdata(gcbf,'data')
      data=getappdata(gcbf,'data');
      if ndims(data)>2
         couronne=get(findobj(gcbf,'tag','couronne'),'Value');
         data=data(:,:,couronne);
         polycouronne=1;
      else
         polycouronne=0;            
      end
   else
      h=warndlg(['Pas de matrice de donnes rentre. '... 
            'La visualisation est impossible'],...
         'Visualisation impossible');
      return;
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'stack'
   % llll
   set(gcbo,'Callback','diagraphiefigcallback(''non coupe'')');
   diagraphiefigcallback('guide','coupe');
   % sera en fait gr par diagraphie
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'non coupe'
   set(gcbo,'Callback','diagraphiefigcallback(''non coupe'');');
   diagraphiefigcallback('guide','non coupe');
   % sera en fait gr par 'diagraphie'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %                                 Frame 'data'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'explorefile' 
   % nnnn
   % Callback du bouton 'explorer le fichier', qui permet de rechercher une
   % matrice  dans  Le fichier
   filename=get(findobj(gcbf,'Tag','filename'),'String');
   pathname=get(findobj(gcbf,'Tag','filename'),'Userdata');
   if  ~isempty(filename)
      choix=feval('who','-file',[pathname filename]);
      [s,v] = listdlg('PromptString','Select a file:',...
         'SelectionMode','single',...
         'ListString',choix); 
      if  ~isempty(s)
         feval('load',[pathname filename],choix{s});
         % Reinitialisation
         diagraphiefigcallback('reset','data');
         %On stocke
         setappdata(gcbf,'data',eval(choix{s}));
         diagraphiefigcallback('set','databrut');
         diagraphiefigcallback('set','data');
         % A priori, on ne peut faire de rorientation
         set(findobj(gcbf,'Tag','oriente'),'value',0);
         set(findobj(gcbf,'Tag','grad'),'value',0,...
            'callback','diagraphiefigcallback(''grad'')');
         set(findobj(gcbf,'Tag','brut'),'value',1);
         set(findobj(gcbf,'Tag','haut'),'value',0);
         set(findobj(gcbf,'Tag','nord'),'value',0);
         set(findobj(gcbf,'Tag','dataname'),'string',choix{s});
      end 
   else
      return
   end
   % Verifier que tout est pret
   if isappdata(gcbf,'data') & isappdata(gcbf,'prof')
      diagraphiefigcallback('guide','pret');
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'workspace'
   % oooo
   % callback du bouton 'workspace' qui permet de rechercher une
   % matrice dans les donnes de l'espace de travail
   % L'espace de travail de cette fonction est different du
   % workspace de travail 
   % On ne peut donc retrouver les donnes
   % Le script est donc recopi tel quel dans le callback 
   % du bouton workspace.
   choix=who;
   [s,v] = listdlg('PromptString','Slectionner la matrice  logguer:',...
      'SelectionMode','single',...
      'ListString',choix);
   if  ~isempty(s)
      %reinitialisation
      diagraphiefigcallback('reset','data');
      % Mise en place
      set(findobj(gcbf,'Tag','Nom'),'string',choix{s});
      setappdata(gcbf,'data',eval(choix{s}));
      setappdata(gcbf,'databrut',eval(choix{s}));
      %On vient de choisir la slection
      set(findobj(gcbf,'Tag','grad'),'value',0,...
         'callback','diagraphiefigcallback(''grad'')');
      set(findobj(gcbf,'Tag','brut'),'value',1);
      set(findobj(gcbf,'Tag','haut'),'value',0);
      set(findobj(gcbf,'Tag','nord'),'value',0);
      set(findobj(gcbf,'Tag','dataname'),'string',choix{s});
      set(findobj(gcbf,'Tag','filename'),'color',grisclair);
   end
   % Verifier que tout est pret
   if isappdata(gcbf,'data') & isappdata(gcbf,'prof')
      diagraphiefigcallback('guide','pret');
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'nom'
   % pppp
   % Ce bout de fonction est la copie du callback de l'editeur du
   % nom de fichier 
   % Il n'a pas pu etre appel par le fichier  cause du 'who'
   % employ se rferant   un workspace diffrent du workspace
   % initial lors qu'il est utilis au sein  d'une fonction
   % Cette portion de code n'est donc ici en tant qu'archive.
   % A l'usage, on se rend compte qu'il est plus pratique de
   % corriger le code ici et de le copier dans la fenetre de
   % cbedit.m (interface d'dition de callback de Matalb) plutot
   % que d'diter dans cette fentre. 
   nom=get(gcbo,'string');
   if isempty(nom)
      return
   end
   filename=get(findobj(gcbf,'Tag','filename'),'String');
   pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
   trouve=0;
   % On recherche d'abord dans le fichier spcifi
   if ~isempty(filename)
      filename=[pathname filename];
      presence=who('-file',filename,nom);
      if ~isempty(presence)
         % Reinitialisation
         diagraphiefigcallback('reset','data');
         % Pose
         trouve=1;
         feval('load',filename,nom);
         setappdata(gcbf,'data',eval(nom));
      end
   end
   % Si on n'a pas encore trouv, chercher dans le workspace
   if ~trouve
      presence=who(nom);
      if ~isempty(presence)
         % Reinitialisation
         diagraphiefigcallback('reset','data');
         % pose
         setappdata(gcbf,'data',eval(nom));
         set(findobj(gcbf,'Tag','grad'),'value',0,...
            'callback','diagraphiefigcallback(''grad'')');
         set(findobj(gcbf,'Tag','brut'),'value',1);
         set(findobj(gcbf,'Tag','haut'),'value',0);
         set(findobj(gcbf,'Tag','nord'),'value',0);
      else
         % Si vraiment, on n'a rien trouv, prvenir et remette  0
         warndlg(['Le nom que vous avez donn ne correspond  aucune donne '...
               'stocke dans le fichier ou dans le workspace'],...
            'Matrice non trouve');
         set(gcbo,'string','');
         return
      end
   end
   % Verifier que tout est pret
   if isappdata(gcbf,'data') & isappdata(gcbf,'prof')
      diagraphiefigcallback('guide','pret');
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %                                 Frame 'prof'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'explorefileprof' 
   % qqqq
   % Callback du bouton 'explorer le fichier', 
   %qui permet de rechercher une matrice dans le fichier
   filename=get(findobj(gcbf,'Tag','filename'),'String');               
   pathname=get(findobj(gcbf,'Tag','filename'),'Userdata');
   if ~isempty(filename)
      filename=[pathname filename];
      choix=feval('who','-file',filename);      
      [s,v] = listdlg('PromptString','Slectionner la matrice  logguer :',... 
         'SelectionMode','single',...
         'ListString',choix);
      if ~isempty(s)
         feval('load',filename,choix{s});
         % rinitialisation
         diagraphiefigcallback('reset','prof');
         %On stocke
         setappdata(gcbf,'prof',eval(choix{s}));
         set(findobj(gcbf,'Tag','profname'),'string',choix{s});
      end
   else
      return
   end
   corrigeok=get(findobj(gcbf,'Tag','corrige'),'value');
   if corrigeok~=0
      prof=eval(choix{s});
      setappdata(gcbf,'profbrut',prof);
      prof=profcorrect(prof);
   end
   setappdata(gcbf,'prof',prof);
   % Si tout est pret
   if isappdata(gcbf,'data') & isappdata(gcbf,'prof')
      diagraphiefigcallback('guide','pret');
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'workspaceprof'
   % rrrr
   % callback du bouton 'workspace' qui permet de rechercher une
   % matrice dans les donnes  de l'espace de travail
   % L'espace de traivail de cette fonction est different du
   % workspace de travail  On ne peut donc retrouver les donnes
   % Le script est donc recopi tel quel dans le callback 
   % du bouton workspace.
   choix=who;
   [s,v] = listdlg('PromptString','Slectionner la matrice  logguer:',...
      'SelectionMode','single',...
      'ListString',choix);
   if  ~isempty(s)
      % Reinitialisation 
      diagraphiefigcallback('reset','prof');
      %
      set(findobj(gcbf,'Tag','Nom'),'string',choix{s});
      setappdata(gcbf,'prof',eval(choix{s}));
      %On vient de choisir la slection
      set(findobj(gcbf,'Tag','filename'),'color',grisclair);
      set(findobj(gcbf,'Tag','profname'),'string',choix{s});
   else 
      return
   end
   setappdata(gcbf,'prof',prof);
   diagraphiefigcallback('set','prof');
   % Verifier que tout est pret
   if isappdata(gcbf,'data') & isappdata(gcbf,'prof')
      diagraphiefigcallback('guide','pret');
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'nomprof'
   % ssss
   % Ce bout de fonction est la copie du callback de l'editer du
   % nom de fichier 
   % Il n'a pas pu etre appel par le fichier  cause du 'who'
   % employ se rferant  un workspace diffrent du workspace
   % initial lors qu'il est utilois au sein d'une fonction
   % Cette portion de code n'est donc ici en tant qu'archive.
   % A l'usage, on se rend compte qu'il est plus pratique de
   % corriger le code ici et de le copier dans la fenetre de
   % cbedit.m (interface d'dition de callback de Matalb) plutot
   % que d'diter dans cette fentre. 
   nom=get(gcbo,'string');  
   if isempty(nom)
      return
   end
   filename=get(findobj(gcbf,'Tag','filename'),'String');
   pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
   trouve=0;
   % On recherche d'abord dans le fichier spcifi
   if ~isempty(filename)
      filename=[pathname filename];
      presence=who('-file',filename,nom);
      if ~isempty(presence)
         trouve=1;
         % rinitialisation
         diagraphiefigcallback('reset','prof');
         % Mise en place
         feval('load',filename,nom);
         prof=eval(nom);
         setappdata(gcbf,'prof',prof);
      end
   end
   % Si on n'a pas encore trouv, chercher dans le workspace
   if trouve==0
      presence=who(nom);
      if ~isempty(presence)
         % rinitialisation
         diagraphiefigcallback('reset','prof');
         % Mise en place
         prof=eval(nom);
         setappdata(gcbf,'prof',prof);
      else
         % Si vraiment, on n'a rien trouv, prvenir et remette  0
         warndlg(['Le nom que vous avez donn ne correspond  aucune donne '...
               'stocke dans le fichier ou dans le workspace'],...
            'Matrice non trouve');
         set(gcbo,'string','');
         return
      end
   end
   corrigeok=get(findobj(gcbf,'Tag','corrige'),'value');
   if corrigeok~=0
      setappdata(gcbf,'profbrut',prof);
      prof=profcorrect(prof);
   end
   % Placer la profondeur dans le fichier
   setappdata(gcbf,'prof',prof);
   diagraphiefigcallback('set','prof');
   % Verifier que tout est pret
   if isappdata(gcbf,'data') & isappdata(gcbf,'prof')
      diagraphiefigcallback('guide','pret');
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %                                 Frame 'offset'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'offset'
   % tttt
   %%% Ce code est en fait copi tel quel dans la case 'Callback'
   % de  l'lment d'dition, puisqu'il est fait explicitement
   % mention au workspace courant.
   offsetstring=get(gcbo,'string');
   offset=str2num(offsetstring);
   % si offset est un entier
   if ~isempty(offset)
      setappdata(gcbf,'offset',offset);
   else
      filename=get(findobj(gcbf,'Tag','filename'),'String');
      pathname=get(findobj(gcbf,'Tag','filename'),'userdata');
      trouve=0;
      % On recherche d'abord dans le fichier spcifi
      if ~isempty(filename)
         filename=[pathname filename];
         if isempty(offsetstring)
            trouve=1;
            set(gcbo,'string','0');
            offset=0;
            setappdata(gcbf,'offset',0);
         else
            presence=who('-file',filename,offsetstring);
            if ~isempty(presence)
               trouve=1;
               feval('load',filename,offsetstring);
               offset=eval(offsetstring);
               setappdata(gcbf,'offset',offset);
            end
         end
      end
      % Si on n'a pas encore trouv, chercher dans le workspace
      if trouve==0
         if isempty(offsetstring)
            trouve=1;
            set(gcbo,'string','0');
            offset=0;
            setappdata(gcbf,'offset',0);
         else
            presence=who(offsetstring);
            if ~isempty(presence)
               offset=eval(offsetstring);
               setappdata(gcbf,'offset',offset);
               trouve=1;
            end
         end
      end
      % Si on a rien trouv : liminer
      if ~trouve
         if isappdata(gcbf,'offset')
            rmappdata(gcbf,'offset');
            set(gcbo,'string',[]);
            return
         end
      end
   end
   % Mettre en place
   if isappdata(gcbf,'prof')
      diagraphiefigcallback('guide','pret');
      formeroffset=str2num(get(gcbo,'Userdata'));
      % Stockage des profondeurs
      if isempty(formeroffset)
         formeroffset=0;
      end
      set(gcbo,'Userdata',num2str(offset));
      % Actualisation des profondeurs marques les prcdentes profondeurs
      offset=offset-formeroffset;
      h=findobj(gcbf,'Tag','pmin','Style','text');
      value=str2num(get(h, 'string'))+offset;
      set(h,'String',num2str(value));
      h=findobj(gcbf,'Tag','pmin','Style','edit');
      value=str2num(get(h, 'string'))+offset;
      set(h,'String',num2str(value));
      h=findobj(gcbf,'Tag','pmax','Style','text');
      value=str2num(get(h, 'string'))+offset;
      set(h,'String',num2str(value));
      h=findobj(gcbf,'Tag','pmax','Style','edit');
      value=str2num(get(h, 'string'))+offset;
      set(h,'String',num2str(value));
   end
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %                                 Frame 'value'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'selectrange' 
   % uuuu
   % Callback de l'aide  la slection des valeurs
   data=getappdata(gcbf,'data');
   if isempty(data)
      return
   end
   V=feval('selectrange',data);
   set(findobj(gcbf,'Tag','vmin'),'string',num2str(V(1)));
   set(findobj(gcbf,'Tag','vmax'),'string',num2str(V(2)));
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %                                 Frame 'colormap'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'colormap'
   % vvvv
   set(gcbo,'BackgroundColor',[...
         0.752941176470588 0.752941176470588 0.752941176470588 ]);    
   maps=get(findobj(gcbf,'Tag','PopupMenu1'),'string');            
   choix=get(findobj(gcbf,'Tag','PopupMenu1'),'value');            
   mapstring=deblank(maps(choix,:));                             
   set(findobj(gcbf,'Tag','colormap'),'String',mapstring);      
   try    
      feval('colormap', mapstring);                  
   catch
      try                                             
         feval('load',mapstring);                     
         feval('colormap', map);                
      catch                                    
         map=feval(mapstring,64);              
         feval('colormap', map);               
      end                                     
   end                                        
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'editcolormap'
   % wwww
   mapstring=deblank(get(findobj(gcbf,'Tag','colormap'),'string'))
   set(findobj(gcbf,'Tag','PopupMenu1'),...
      'BackgroundColor',[0 0 0 ]);
   try 
      feval('colormap', mapstring);
   catch
      try 
         feval('load',mapstring); feval('colormap', map);
      catch         
         try
            map=feval(mapstring,64); feval('colormap', map); 
         catch
         end
      end 
   end 
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %                                 Frame 'bloc'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'debut'
   % xxxx
   bloc=str2num(get(gcbo,'string'));
   taille=str2num(get(findobj(gcf,'Tag','taille'),'string'));
   bloc=max(min(bloc,taille),1);
   set(gcbo,'string',num2str(bloc));
   if isappdata(gcbf,'prof')
      prof=getappdata(gcbf,'prof');
      if isappdata(gcbf,'offset')
         offset=getappdata(gcbf,'offset');
         prof=prof+offset;
      end
      set(findobj(gcbf,'tag','pmin','style','edit'),...
         'string',num2str(prof(bloc)));
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'fin'   
   bloc=str2num(get(gcbo,'string'));
   taille=str2num(get(findobj(gcf,'Tag','taille'),'string'));
   bloc=max(min(bloc,taille),1);
   set(gcbo,'string',num2str(bloc));
   if isappdata(gcbf,'prof')
      prof=getappdata(gcbf,'prof');
      if isappdata(gcbf,'offset')
         offset=getappdata(gcbf,'offset');
         prof=prof+offset;
      end
      set(findobj(gcbf,'tag','pmin','style','edit'),...
         'string',num2str(prof(bloc)));
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'selectbloc'
   % Callback de l'aide  la slection des valeurs
   if ~isappdata(gcbf,'data')
      return
   end
   if isappdata(gcbf,'prof')
      prof=getappdata(gcbf,'prof');
      if isappdata(gcbf,'offset')
         offset=getappdata(gcbf,'offset');
         prof=prof+offset;
      end
   else 
      return
   end
   V=feval('selectbloc',prof);
   % Blocs
   set(findobj(gcbf,'style','edit','Tag','debut'),...
      'string',num2str(ceil(V(1))));
   set(findobj(gcbf,'style','edit','Tag','fin'),...
      'string',num2str(floor(V(2))));
   % Profondeurs
   set(findobj(gcbf,'userdata','profondeur','style','edit','Tag','pmin'),...
      'String',num2str(prof(ceil(V(1)))));
   set(findobj(gcbf,'userdata','profondeur','style','edit','Tag','pmax'),...
      'string',num2str(prof(floor(V(2)))));
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %                                 Frame 'profondeur'
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'pmin'
   % yyyy
   bloc=str2num(get(gcbo,'string'));
   pmin=str2num(get(findobj(gcf,'style','text','Tag','pmin'),'string'));
   pmax=str2num(get(findobj(gcbf,'style','text','Tag','pmax'),'string'));
   bloc=max(min(bloc,pmax),pmin);
   set(gcbo,'string',num2str(bloc));
   % Il faut adapter les indices
   pmin=bloc;
   pmax=str2num(get(findobj(gcf,'style','edit','Tag','pmax'),'string'));
   V=sort([pmin pmax]);
   if isappdata(gcbf,'prof')
      prof=getappdata(gcbf,'prof');
      if isappdata(gcbf,'offset')
         offset=getappdata(gcbf,'offset');
         prof=prof+offset;
      end
      I=find((prof<=V(2))&(prof>=V(1)));
      set(findobj(gcf,'tag','debut'),'string',num2str(I(1)));
      set(findobj(gcf,'tag','fin'),'string',num2str(I(length(I))));
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'pmax'
   bloc=str2num(get(gcbo,'string'));
   pmin=str2num(get(findobj(gcf,'style','text','Tag','pmin'),'string'));
   pmax=str2num(get(findobj(gcbf,'style','text','Tag','pmax'),'string'));
   bloc=max(min(bloc,pmax),pmin);
   set(gcbo,'string',num2str(bloc));
   % Il faut adapter les indices
   pmin=str2num(get(findobj(gcf,'style','edit','Tag','pmin'),'string'));
   pmax=bloc;
   V=sort([pmin pmax]);
   if isappdata(gcbf,'prof')
      prof=getappdata(gcbf,'prof');
      if isappdata(gcbf,'offset')
         offset=getappdata(gcbf,'offset');
         prof=prof+offset;
      end
      I=find((prof<=V(2))&(prof>=V(1)));
      set(findobj(gcf,'tag','debut'),'string',num2str(I(1)));
      set(findobj(gcf,'tag','fin'),'string',num2str(I(length(I))));
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'selectprof'
   if ~isappdata(gcbf,'data')
      return
   end
   if isappdata(gcbf,'prof')
      prof=getappdata(gcbf,'prof');
   else 
      return
   end
   V=feval('selectprof',prof);
   % On affiche les profondeurs limites slectionnes
   set(findobj(gcbf,'userdata','profondeur','style','edit','Tag','pmin'),....
      'String',num2str(V(1)));
   set(findobj(gcbf,'userdata','profondeur','style','edit','Tag','pmax'),...
      'string',num2str(V(2)));
   % On affiche les blocs limites slectionns
   I=find((prof<=V(2))&(prof>=V(1)));
   set(findobj(gcf,'tag','debut'),'string',num2str(I(1)));
   set(findobj(gcf,'tag','fin'),'string',num2str(I(length(I))));
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
case 'orientation'
   current=gcf; 
   fig=diagraphieorientation;
   if isappdata(current,'orientation');
      orientation=getappdata(current,'orientation');
      gamma=orientation(:,2);
      lambda=orientation(:,1);
      setappdata(fig,'azimut',gamma);
      setappdata(fig,'incidence',lambda);
      if ndims(gamma)>1
         gamma=mean(gamma(:));
      end
      set(findobj(fig,'Tag','AzimutMoyen'),...
         'string',num2str(gamma));
      if ndims(lambda)>1
         lambda=mean(lambda(:));
      end
      set(findobj(fig,'Tag','IncidenceMoyenne'),...
         'string',[num2str(lambda) '']);
      if isappdata(gcf,'file')
         setappdata(fig,'file',getappdata(gcf,'file'));
         set(gcbo,'Checked','on');
      end
   end;
   figure(fig);
   uiwait;
   if isappdata(fig,'orientation');
      orientation=getappdata(fig,'orientation');
      setappdata(current,'orientation',orientation);
   end;
   delete('workspaceprovisoire.mat');  
   close(fig); 
   set(gcbo,'Checked','on')
end
