% diagraphieorientationcallback
%
%   Callback d'interface graphique de la figure orientation qui
%   permet de choisir les  ou de corriger l'orientation du forage,
%   determine par son pendage et son azimut 
%

function diagraphieorientationcallback(action);

 switch action   
 case 'validation'
    if isappdata(gcbf,'incidence') & isappdata(gcbf,'azimut')
        lambda=getappdata(gcbf,'incidence');
        gamma=getappdata(gcbf,'azimut');
        if ~isequal(ndims(lambda),ndims(gamma))
           lambda=lambda.*ones(size(gamma));
           gamma=gamma.*ones(size(lambda));
        end
        setappdata(gcbf,'orientation',[lambda gamma]);
    else
        disp('return')
        return
    end 
    uiresume;    
 case 'azimutedit'
    gamma=str2num(get(gcbo,'string'));
    setappdata(gcbf,'azimut',gamma);
    set(findobj(gcbf,'tag','azimutorigine'),'string','(entree manuelle)');
    if ndims(gamma)>1
        gamma=mean(gamma(:));
    end
    set(findobj(gcbf,'Tag','AzimutMoyen'),'string',[num2str(gamma) '']);
  case 'azimutfile'
   if isappdata(gcbf,'file')
     file=getappdata(gcbf,'file')
     if  ~isempty(file)
       choix=feval('who','-file',file);         
       [s,v] = listdlg('PromptString','Slectionner l''azimut :',... 
		       'SelectionMode','single',...     
		       'ListString',choix);    
       if  ~isempty(s)
	 feval('load',file,choix{s});
	 gamma=choix{s};
	 setappdata(gcbf,'azimut',gamma);
	 set(findobj(gcbf,'tag','azimutorigine'),...
	     'string',['(fichier ' file ')']);
	 if ndims(gamma)>1
	   gamma=mean(gamma(:));
	 end
	 set(findobj(gcbf,'Tag','AzimutMoyen'),...
	     'string',[num2str(gamma) '']);
       end
     end 
   end
  case 'azimutworkspace'
   choix=feval('who','-file','workspaceprovisoire.mat');
   [s,v] = listdlg('PromptString','Slectionner l''azimut :',... 
		   'SelectionMode','single',... 
		   'ListString',choix);              
   if  ~isempty(s)
     feval('load','workspaceprovisoire.mat',choix{s});
     gamma=choix{s};
     setappdata(gcbf,'azimut',gamma);
     set(findobj(gcbf,'tag','azimutorigine'),'string','(workspace)');
     if ndims(gamma)>1
       gamma=mean(gamma(:));
     end
     set(findobj(gcbf,'AzimutMoyen'),'string',[num2str(gamma) '']);
   end
  case 'incidenceedit'
   lambda=str2num(get(gcbo,'string'));
   setappdata(gcbf,'incidence',lambda);
   set(findobj(gcbf,'tag','incidenceorigine'),'string','(entree manuelle)');
   if ndims(lambda)>1
     lambda=mean(lambda(:));
   end
   set(findobj(gcbf,'Tag','IncidenceMoyenne'),'string',[num2str(lambda) '']);
  case 'incidencefile'
   if isappdata(gcbf,'file')
     file=getappdata(gcbf,'file')
     if  ~isempty(file)
       choix=feval('who','-file',file);
       [s,v] = listdlg('PromptString','Slectionner l''incidence :',... 
		       'SelectionMode','single',...    
		       'ListString',choix);               
       if  ~isempty(s)
	 feval('load',file,choix{s});
	 lambda=choix{s};
	 setappdata(gcbf,'incidence',lambda);
	 set(findobj(gcbf,'tag','incidenceorigine'),...
	     'string',['(fichier ' file ')']);
	 if ndims(lambda)>1
	   lambda=mean(lambda(:));
	 end
	 set(findobj(gcbf,'Tag','IncidenceMoyenne'),...
	     'string',[num2str(lambda) '']);
       end
     end 
   end
  case 'incidenceworkspace'
   choix=feval('who','-file','workspaceprovisoire.mat');
   [s,v] = listdlg('PromptString','Slectionner l''incidence :',... 
		   'SelectionMode','single',...    
		   'ListString',choix);                  
     if  ~isempty(s)
         feval('load','workspaceprovisoire.mat',choix{s});
         lambda=choix{s};
         setappdata(gcbf,'incidence',lambda);
         set(findobj(gcbf,'tag','incidenceorigine'),'string','(workspace)');
         if ndims(lambda)>1
             lambda=mean(lambda(:));
         end
         set(findobj(gcbf,'Tag','IncidenceMoyenne'),...
	     'string',[num2str(lambda) '']);
     end
 end