% IMAGINGLINEEDIT gre les lments graphiques de la ligne de slection
%
%  SYNTAXE
%        fig=imaginglineedit(idline);
%             fig = handle de la figure
%             idlines = identificateur des lignes de slection 
%
%=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=--=-=-=-=-=-=-=-=-=-=--=-=-=-==-==-=--=-=-=-=
%
%

function fig=imaginglineedit(idline);
if ~ischar(idline)
   current=gcf;
   fig=imaginglineeditfig;
   if isappdata(current,'figdata');
       figdata=getappdata(current,'figdata');
       if isappdata(figdata,'orientation');
           setappdata(fig,'orientation',getappdata(figdata,'orientation'));
       end
   end
   if isappdata(current,'file')
       setappdata(fig,'file',getappdata(current,'file'));
   end
   set(fig,'Userdata',idline);
   set(allchild(fig),'Userdata',idline);
   
   debline=findobj('Type','line','Userdata',idline,'Tag','debline');
   debcolor=get(debline,'Color');
   debaxis=get(debline,'Parent'); debaxnumber=get(debaxis,'Userdata');
   debpoint=get(debline,'Ydata');debpoint=debpoint(1);
   debbloc=250*(debaxnumber-1)+floor(debpoint);
   
   finline=findobj('Type','line','Userdata',idline,'Tag','finline');
   fincolor=get(finline,'Color');
   finaxis=get(finline,'Parent'); finaxnumber=get(finaxis,'Userdata');
   finpoint=get(finline,'Ydata');finpoint=finpoint(1);
   finbloc=250*(finaxnumber-1)+ceil(finpoint);
   
   set(findobj(gcf,'Tag','debcolor'),'BackgroundColor',debcolor);
   set(findobj(gcf,'Tag','fincolor'),'BackgroundColor',fincolor);
   set(findobj(gcf,'Tag','debbloc'),'String', num2str(debbloc));
   set(findobj(gcf,'Tag','finbloc'),'String', num2str(finbloc));
   
   callingfig=get(finaxis,'Parent'); iddiagraphie=get(callingfig,'Userdata');
   %   set(fig,'Filename', num2str(iddiagraphie));
   
   % PAramtres permettant  imaging(''closing'') de fermer toutes
   % les fentres relatives  la diagraphie principale
   editfig=getappdata(callingfig,'lineeditfig');
   editfig=[editfig fig];
   setappdata(callingfig,'lineeditfig',editfig);
   setappdata(debline,'lineeditfig',fig);
   setappdata(finline,'lineeditfig',fig);
   setappdata(fig,'id',idline);
   setappdata(fig,'caller',iddiagraphie);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% CALLBACKS DE L'INTERFACE GRAPHIQUE %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
else
   switch lower(deblank(idline))
   case 'colorselect'
      id=get(gcbo,'Userdata');
      defcolor=get(gcbo,'BackgroundColor');
      C=uisetcolor(defcolor);
      set(gcbo,'BackgroundColor',C);         
      if get(gcbo,'Tag')=='debcolor'
         set(findobj('Tag','debline','Userdata', id),'Color',C);
      else 
         set(findobj('Tag','finline','Userdata', id),'Color',C);
      end        
   case 'debbloc'
      % identificateurs
      id=get(gcbo,'UserData');
      debline=findobj('Type','line','Userdata',id,'Tag','debline');
      debaxis=get(debline,'Parent');
      debfigure=get(debaxis,'Parent');
      iddiagraphie=get(debfigure,'Userdata');
      % lectures
      debbloc=str2num(get(findobj(gcbf,'Tag','debbloc'),'string'));
      axnumber=ceil(debbloc/250);
      Ydebbloc=mod(debbloc,250);
      if Ydebbloc==0
         Ydebbloc=250;
      end
      % On rcupre les donnes de la ligne
      color=get(debline,'Color'); tag=get(debline,'Tag');
      % on limine la ligne ...
      delete(debline);
      % ... et on la recre dans sa nouvelle position
      % nouvelle position
      newax=findobj(findobj('Type','figure','Userdata',iddiagraphie),...
         'Type','Axes','Userdata',axnumber);
      newfig=get(newax,'Parent');
      axes(newax);
      line=plot(xlim,Ydebbloc*[1 1],':',...
		'EraseMode','xor',...
		'LineWidth', 3, ...
		'Userdata',id,...
		'ButtonDownFcn', 'imaginglines(''selection'');',...
		'Color',color,...
		'Tag',tag);      
      % gestion des menus
      reste=findobj(debfigure,'Type', 'line','Userdata',id);
      present=findobj(newfig,'Type','uimenu','Userdata',id);
      if isempty(reste)
         menu=findobj('Type','uimenu','Userdata',id);
         delete(menu);
      end
      if isempty(present)
   		figure(newfig);
         imaginglines('setmenu',id);
      end
   case 'finbloc'
      % identificateurs
      id=get(gcbo,'UserData');
      finline=findobj('Type','line','Userdata',id,'Tag','finline');
      finaxis=get(finline,'Parent');
      finfigure=get(finaxis,'Parent');
      iddiagraphie=get(finfigure,'Userdata');
      % lectures et calcul des positions
      finbloc=str2num(get(findobj(gcbf,'Tag','finbloc'),'string'));
      axnumber=ceil(finbloc/250);
      Yfinbloc=mod(finbloc,250);
      if Yfinbloc==0
         Yfinbloc=250;
      end
      % On rcupre les donnes de la ligne
      color=get(finline,'Color'); tag=get(finline,'Tag');
      % on limine la ligne ...
      delete(finline);
      % ... et on la recre dans sa nouvelle position
      fig=findobj('Type','figure','Userdata',iddiagraphie);
      newax=findobj(fig,'Type','Axes','Userdata',axnumber);
      axes(newax);
      newfig=get(newax,'Parent');
      line=plot(xlim,Yfinbloc*[1 1],':',...
		'EraseMode','xor',...
		'LineWidth', 3,...
		'Userdata',id,...
		'ButtonDownFcn', 'imaginglines(''selection'');',...
		'Color',color,...
		'Tag',tag);
      % gestion des menus
      reste=findobj(finfigure,'Type', 'line','Userdata',id);
      present=findobj(newfig,'Type','uimenu','Userdata',id);
      if isempty(reste)
         menu=findobj('Type','uimenu','Userdata',id);
         delete(menu);
      end
      if isempty(present)
   		figure(newfig);
	      imaginglines('setmenu',id);
      end
   case 'blink'
      identificateur=get(gcbo,'Userdata');
      tag=get(gcbo,'Tag');
      if strcmp(tag,'menulocation')
         menuedit=findobj('Type','uimenu',...
			  'Userdata',identificateur,...
			  'Label','Polaire');
         if length(menuedit)>1
            menuedit=menuedit(1);
         end
         currentfigure=gcf;
         titre=get(menuedit,'Label');
         figure(get(menuedit,'Parent'));
         for j=1:3
            set(menuedit,'Label','Ici ! Ici !');
            pause(0.2);
            set(menuedit,'Label',titre);
            pause(0.2);
         end
         figure(currentfigure);
      else
         debline=findobj('Type','line','Tag','debline',...
			 'Userdata',identificateur);
         finline=findobj('Type','line','Tag','finline',....
			 'Userdata',identificateur);
         colordeb=get(debline,'Color'); % couleurs initiales
         colorfin=get(finline,'Color');
         coldeb=colordeb;		% couleurs  modifier
         colfin=colorfin;
         currentfigure=gcf;
         switch tag
         case 'deblocation'
            debaxis=get(debline,'Parent'); fig=get(debaxis,'Parent');
            col=coldeb;
            ligne=debline;
         case 'finlocation'
            finaxis=get(finline,'Parent'); fig=get(finaxis,'Parent');
            col=colfin;
            ligne=finline;
         otherwise
            debaxis=get(debline,'Parent'); fig=get(debaxis,'Parent');
            col=coldeb;			% de toutes facon on ne
                                        % veut qu'observer les lignes. 
            				% la couleur importe peu 
            ligne=findobj('Type','line','Userdata', identificateur);
         end
         figure(fig);
	      if ~isequal(col(1),col(2),col(3))      
            for j=1:6
               col=[col(3) col(1:2)];
               set(ligne,'Color',col);
               pause(0.2);
            end
         else
            for j=1:6
               col=mod(col+1/3,1);
               set(ligne,'Color',col);
               pause(0.2);
            end
         end
         % Les lignes reprennent leur couleurs initiales.
         set(debline,'Color',colordeb);
	      set(finline,'Color',colorfin);
      end
  case 'orientation' %menu orientation
      current=gcf; 
      fig=diagraphieorientation;
      if isappdata(current,'orientation');
          orientation=getappdata(current,'orientation');
          gamma=orientation(:,2);
          lambda=orientation(:,1);
          setappdata(fig,'azimut',gamma);
          setappdata(fig,'incidence',lambda);
          if ndims(gamma)>1
             gamma=mean(gamma(:));
          end
          set(findobj(fig,'Tag','AzimutMoyen'),'string',num2str(gamma));
          if ndims(lambda)>1
             lambda=mean(lambda(:));
          end
          set(findobj(fig,'Tag','IncidenceMoyenne'),...
	      'string',[num2str(lambda) '']);
          if isappdata(gcf,'file')
              setappdata(fig,'file',getappdata(gcf,'file'));
              set(gcbo,'Checked','on');
          end
      end;
      figure(fig);
      uiwait;
      if isappdata(fig,'orientation');
          orientation=getappdata(fig,'orientation');
          setappdata(current,'orientation',orientation);
      end;
      delete('workspaceprovisoire.mat');  
      close(fig); 
      set(gcbo,'Checked','on')
   end
end




