% IMAGINGLINES gestion des lignes et des applications que l'on peut en faire.
%
% Ce script est en fait une sous-fonction de imaging.m ,le
% programme d'affichage de diagraphies lectriques.
%
%    SYNTAXE
%           idline=imaginglines(action,option)
%				
%  Mise en contexte :
%	imaging a t appel, peut_tre  partir de diagraph
% 	La diagraphie s'affiche en une srie de figures de 5
% 	colonnes. Si on clique sur l'image de ces colonnes, ce
% 	script s'enclenche : 
%		- il plotte 2 lignes horizontales de slection
%		- il ajoute un menu sur la barre de menu de la
%		  figure appelante. 
%   On gre dans ce script le dplacement des lignes dans la
%  diagraphie. On est ainsi capable de couvrir toutes les figures. 
%   La gestion des lignes par la suite est couverte par ce
%  script, qui gere leur dplacement et les application comme le
%  lancer des diagrammes polaires. 
%   La gestion plus terre  terre, comme celle couverte par la
%   figure d'dition des lignes  est donne par imaginglineedit.
%	
% =-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-==-==-=--=-=-=-=-=-=-=-
% 

function idline=imaginglines(action, option)
% Situation : On vient de cliquer sur une colonne de la diagraphie

if nargin==0
    %%% IDENTIFICATEUR
    %% identificateur commun  tous les lments d'interface
    %graphiques associs 
    idline=now; % identificateur des boutons de slection du
    % diagramme polaire
    % en fait, l'heure de slection
    iddiagraphie=get(gcf,'Userdata');                         
    current=gcf;                     
    %%% POSITION DU POINT CHOISI ET BLOC CORRESPONDANT
    % On vient de cliquer sur une image :                         
    hndl = get(gcbf,'CurrentObject'); 
    % On en dduit l'axe sur lequel cette image a t trace
    lineaxis = get(hndl,'Parent');
    axnumber=get(lineaxis,'Userdata'); % Numro de la colonne, vis 
    % vis de TOUTE la diagraphie 
    % On en devine la position du point choisi 
    % l'ordonne est compte en blocs, par rapport au dbut de la ligne. 
    point = get(lineaxis,'CurrentPoint'); 
    currentbloc=point(1,2);
    % On en dduit le numro du bloc vis  vis de toute la diagraphie,
    %	sachant qu'il y a 250 blocs par colonne
    currentbloc=floor(currentbloc)+250*(axnumber-1);
    
    %%% PREPOSITIONNEMENT DES LIGNES DE SELECTION
    % Blocs des lignes de slection
    debbloc=currentbloc-10;
    finbloc=currentbloc+10;
    % Figure de tracage, sachant qu'il y a 5*250 blocs par figure de 5 colonnes
    debfig=ceil(debbloc/(250*5));
    finfig=ceil(finbloc/(250*5));
    % Axe de tracage
    debaxe=ceil(debbloc/250);
    debaxe=findobj(findobj('Type','figure','Userdata',iddiagraphie),...
        'Type','Axes',...
        'UserData',debaxe);
    finaxe=ceil(finbloc/250);
    finaxe=findobj(findobj('Type','figure','Userdata',iddiagraphie),...
        'Type','Axes',...
        'UserData',finaxe); 
    %%% TRACE 
    % Trac des lignes de slection
    xlim  = get(lineaxis,'Xlim');
    Ydebbloc=mod(debbloc,250);
    if Ydebbloc==0
        Ydebbloc=250;
    end
    Yfinbloc=mod(finbloc,250);
    if Yfinbloc==0
        Yfinbloc=0
    end
    axes(debaxe);
    debline=plot(xlim,Ydebbloc*[1 1],':',...
        'EraseMode','xor',....
        'LineWidth', 3,...
        'Userdata',idline,...
        'ButtonDownFcn', 'imaginglines(''selection'');',...
        'Color',[1 0 0],...
        'Tag','debline');
    axes(finaxe);
    finline=plot(xlim,Yfinbloc*[1 1],':',...
        'EraseMode','xor',...
        'LineWidth', 3,...
        'Userdata',idline,...
        'ButtonDownFcn', 'imaginglines(''selection'');',...
        'Color',[1 0 0],...
        'Tag','finline');
    % Menu de contrle
    
    %%% MENUS   
    if debfig==finfig
        % On est sur la mme figure
        axes(debaxe);
        imaginglines('setmenu',idline);
    else
        axes(debaxe);
        imaginglines('setmenu',idline);
        axes(finaxe);
        imaginglines('setmenu',idline);
    end
    
    %%% FIGURE DE CONTROLE DES LIGNES   
    figedit=imaginglineedit(idline);
    if isappdata(current,'file')
        file=getappdata(current,'file');% Fichier d'origine de la diagraphie
        setappdata(figedit,'file',file);
    end
    if isappdata(current,'figdata')
        figdata=getappdata(current,'figdata');
        if isappdata(figdata,'orientation')
            orientation=getappdata(figdata,'orientation');
            % Orientation du forage;
            setappdata(figedit,'orientation',orientation);
        end
    end
    
    %%% POSITION DES ELECTRODES
    prof=getappdata(figdata,'profondeur');
    elecbloc=find(abs(prof-prof(currentbloc)-3)<0.02);
    if ~isempty(elecbloc)
        for i=1:length(elecbloc)
            elecaxe=ceil(elecbloc(i)/250);
            elecaxe=findobj(findobj('Type','figure',...
                'Userdata',iddiagraphie),...
                'Type','Axes',...
                'UserData',elecaxe);
            Yelecbloc=mod(elecbloc(i),250);
            if Yelecbloc==0
                Yelecbloc=250;
            end
            axes(elecaxe)
            elecline=plot(xlim,Yelecbloc*[1 1],'-',...
                'EraseMode','xor',...
                'LineWidth', 10,...
                'Userdata',idline,...
                'Color',[0 0 0],...
                'Tag','elecline');
        end
    end 
    
    figure(figedit);
    setappdata(debline,'id',idline);
    setappdata(finline,'id',idline);
    setappdata(debline,'bloc',debbloc);
    setappdata(finline,'bloc',finbloc);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%% CALLBACKS DE L'INTERFACE GRAPHIQUE %%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
else
    switch lower(deblank(action))
    case 'setmenu'
        idline=option;
        polarmenu=uimenu('Label','Polaire',...
            'Userdata',idline,...
            'ButtonDownFcn','imaginglineedit(''blink'')',...
            'foregroundcolor',[0.5 0.5 0]);
        blinkpolarmenu=uimenu(polarmenu,'Label','O sont-elles ?',...
            'Callback','imaginglineedit(''blink'')',...
            'Userdata',idline);
        deletepolarmenu=uimenu(polarmenu,'Label','Effacer',...
            'Callback','imaginglines(''efface'')',...
            'Userdata',idline);
        plotpolarmenu=uimenu(polarmenu,'Label','Dessiner',...
            'Callback','imaginglines(''polaire'')',...
            'Userdata',idline);
        lineeditmenu=uimenu(polarmenu,'Label','Editer les lignes',...
            'Callback','imaginglines(''edition'')',...
            'Userdata',idline);
    case 'selection'
        hndl = get(gcbf,'CurrentObject');
        fig=gcf;
        set(hndl,'Visible','off','LineWidth', 5);
        set(hndl,'Visible','on');
        set(gcf,'WindowButtonUpFcn', 'imaginglines(''haut'');', ...
            'WindowButtonMotionFcn', 'imaginglines(''deplace'');');
        id=get(hndl,'Userdata');
        editfig=findobj('Type','figure','Userdata',id,'Tag','lineedit');
        if ~isempty(editfig)
            figure(editfig);
        end
        figure(fig);
    case 'deplace'
        hndl = get(gcbf,'CurrentObject');
        id=get(hndl,'Userdata');
        %  Get the current cursor point and axis limits
        lineaxis = get(hndl,'Parent');
        axnumber=get(lineaxis,'Userdata');
        point = get(lineaxis,'CurrentPoint');
        ordonnee=point(1,2);
        xlim  = get(lineaxis,'Xlim');
        ylim  = get(lineaxis,'Ylim');
        %  Update the slider line display
        newpt= min(max(ordonnee,ylim(1)),ylim(2));
        newbloc=newpt+250*(axnumber-1);
        set(hndl, 'Ydata', newpt*[1 1]);      
        % actualise si il y en a besoin la figure de controle
        % associee aux lignes
        editfig=findobj('Type','figure','Tag','lineedit', 'Userdata',id);
        if ~isempty(editfig)
            switch get(hndl,'Tag')
            case 'debline'
                set(findobj(editfig,'Tag','debbloc'),...
                    'String',num2str(ceil(newbloc)));
            case 'finline'
                set(findobj(editfig,'Tag','finbloc'),...
                    'String',num2str(floor(newbloc)));   
            end
        end
    case 'haut'
        %  Change the line slider width and set the appropriate
        %  window properties.
        hndl = get(gcbf,'CurrentObject');
        set(gcf, 'WindowButtonUpFcn','',...
            'WindowButtonMotionFcn','');
        set(hndl,'Visible','off');
        set(hndl, 'LineWidth', 1,...
            'ButtonDownFcn', 'imaginglines(''selection'');');
        set(hndl,'Visible','on');
        %  Si on est en limite d'axe, proposer de passer  l'axe suivant
        lineaxis = get(hndl,'Parent');
        axnumber=get(lineaxis,'Userdata');
        pos=get(lineaxis,'Position');
        point = get(lineaxis,'CurrentPoint');
        ordonnee=point(1,2);
        ylim  = get(lineaxis,'Ylim');
        Largeurbouton=0.03;
        id=get(hndl,'Userdata');
        if floor(ordonnee)<=ylim(1)	  % Ligne en haut de colonne
            % On s'assure que ce n'est pas le premier axe
            if axnumber~=1
                % On rappelle que la position des axes est donnee par
                % [Xcoinbasgauche Ycoinbasgauche Xlarge Ylarge]
                tag=get(hndl,'Tag');
                if tag=='debline'
                    callback=['imaginglines(''left'',''debline'')'];
                else
                    callback=['imaginglines(''left'',''finline'')'];
                end
                buttonposition=[pos(1) (pos(2)+pos(4)) pos(3) Largeurbouton];
                left=uicontrol('Style','Pushbutton',....
                    'string','<<',...
                    'Callback',callback,...
                    'Tag','left',...
                    'Units','normalized',...
                    'Position',buttonposition,...
                    'Userdata',id);
            end
        elseif ceil(ordonnee)>=ylim(2)  % Ligne en bas de colonne
            next=findobj('Type','Axes','Userdata',axnumber+1);
            %  On s'assure que ce n'est pas le dernier axe
            if ~isempty(next)
                buttonposition=[pos(1) (pos(2)-Largeurbouton)...
                        pos(3) Largeurbouton];
                tag=get(hndl,'Tag');
                if tag=='debline'
                    callback=['imaginglines(''right'',''debline'')'];
                else
                    callback=['imaginglines(''right'',''finline'')'];
                end
                right=uicontrol('Style','Pushbutton',...
                    'string','>>',...
                    'Callback',callback,...
                    'Tag','right',...
                    'Units','normalized',...
                    'Position', buttonposition,....
                    'Userdata',id );
            else 
                push=findobj(gcf,'Style','pushbutton') ;
                delete(push);
            end
        end
        
    case 'left'
        id=get(gcbo,'Userdata');
        line=findobj('Type','line', 'Tag',option,'Userdata',id);
        % recupration des paramtres de la lignes
        tag=get(line,'Tag'); color=get(line,'Color'); 
        lineaxis=get(line,'Parent');
        currentfigure=get(lineaxis,'Parent');
        iddiagraphie=get(currentfigure,'UserData');
        % nouveaux axes
        axnumber=get(lineaxis,'Userdata');
        newax=findobj(findobj('Type','Figure','Userdata',iddiagraphie),...
            'Type','Axes','Userdata',axnumber-1);
        if isempty(newax)
            return
        end
        xlim=get(newax,'Xlim');
        % recration de la ligne
        delete(line);
        axes(newax);
        line=plot(xlim,[250 250],':',...
            'EraseMode','xor',...
            'LineWidth', 3,...
            'Userdata',id,...
            'ButtonDownFcn', 'imaginglines(''selection'');',...
            'Color',color,...
            'Tag',tag);
        nextfigure=get(newax,'Parent');
        % Actualisation ventuelle des menus
        reste=findobj(currentfigure,'Type', 'line','Userdata',id);
        present=findobj(nextfigure,'Type','uimenu','Userdata',id);
        if isempty(reste)
            menu=findobj(currentfigure,'Type','uimenu','Userdata',id);
            delete(menu);
        end
        if isempty(present)
            figure(nextfigure);
            imaginglines('setmenu',id);
        end
        % On actualise les blocs si la figures d'dition existe
        editfig=findobj('Type','figure','Userdata',id,'Tag','lineedit');
        if ~isempty(editfig)
            if option=='debline'
                edithndl=findobj(editfig,'Tag','debbloc');
                bloc=str2num(get(edithndl,'String'));
                set(edithndl,'string',num2str(bloc-1));
            else
                edithndl=findobj(editfig,'Tag','finbloc');
                bloc=str2num(get(edithndl,'String'));
                set(edithndl,'string',num2str(bloc-1));
            end
        end
        % On elimine bouton 'axe  gauche'...
        delete(gcbo);
        
    case 'right'
        id=get(gcbo,'Userdata');
        line=findobj('Type','line', 'Tag',option,'Userdata',id);
        % recupration des paramtres de la lignes
        tag=get(line,'Tag'); color=get(line,'Color'); 
        lineaxis=get(line,'Parent');
        currentfigure=get(lineaxis,'Parent');
        iddiagraphie=get(currentfigure,'UserData');
        % nouveaux axes
        axnumber=get(lineaxis,'Userdata');
        newax=findobj(findobj('Type','Figure','Userdata',iddiagraphie),...
            'Type','Axes','Userdata',axnumber+1);
        if isempty(newax)
            return
        end
        xlim=get(newax,'Xlim');
        % recration de la ligne
        delete(line);
        axes(newax);
        line=plot(xlim,[1 1],':',...
            'EraseMode','xor',...
            'LineWidth', 3,...
            'Userdata',id,...
            'ButtonDownFcn', 'imaginglines(''selection'');',...
            'Color',color,...
            'Tag',tag);
        nextfigure=get(newax,'Parent');
        % Actualisation des menus
        reste=findobj(currentfigure,'Type', 'line','Userdata',id);
        present=findobj(nextfigure,'Type','uimenu','Userdata',id);
        if isempty(reste)
            menu=findobj('Type','uimenu','Userdata',id);
            delete(menu);
        end
        if isempty(present)
            figure(nextfigure);
            imaginglines('setmenu',id);
        end
        % On actualise les blocs si la figure d'dition existe
        editfig=findobj('Type','figure','Userdata',id,'Tag','lineedit');
        if ~isempty(editfig)
            if option=='debline'
                edithndl=findobj(editfig,'Tag','debbloc');
                bloc=str2num(get(edithndl,'String'));
                set(edithndl,'string',num2str(bloc+1));
            else
                edithndl=findobj(editfig,'Tag','finbloc');
                bloc=str2num(get(edithndl,'String'));
                set(edithndl,'string',num2str(bloc+1));
            end
        end
        % On limine le bouton vers la gauche
        delete(gcbo);
    case 'edition'
        id=get(gcbo,'Userdata');
        editfig=findobj('Type','figure','Userdata',id,'Tag','lineedit');
        if isempty(editfig)
            editfig=imaginglineedit(id);
        else
            figure(editfig);
        end
    case 'efface'
        delete(findobj('Userdata',get(gcbo,'Userdata')));
    case 'polaire'      
        identificateur=get(gcbo,'Userdata');
        % identificateur des lments graphiques
        % associs  l'criture des diagrammes polaires => menu d'appel et 
        % lignes de controle
        
        % Position de la ligne de dbut et bloc associ
        debline=findobj('Tag','debline','Userdata',identificateur);
        debaxis=get(debline,'Parent');
        debfigure=get(debaxis,'Parent');
        debpoint=get(debline,'Ydata'); debpoint=debpoint(1);
        axnumberdeb=get(debaxis,'UserData');
        blocmin=250*(axnumberdeb-1)+floor(debpoint);
        
        % Position de la ligne de dbut et bloc associ
        finline=findobj('Type','line',...
            'Tag','finline',...
            'Userdata',identificateur);
        finaxis = get(finline,'Parent');
        finpoint=get(finline,'Ydata');finpoint=finpoint(1);
        axnumberfin=get(finaxis,'UserData');
        blocmax=250*(axnumberfin-1)+ceil(finpoint);
        
        % identificateur des lments graphiques associs 
        % l'affichage de la diagraphie => figure
        debfigure=get(debaxis,'Parent');
        figdata=getappdata(debfigure,'figdata');
        donnee=getappdata(figdata,'donnee');
        profdata=getappdata(figdata,'profondeur');
        V=blocmin:blocmax;
        V=sort(V);
        % Protection des donnes
        if (V(length(V))-V(1))>=100
            answer=questdlg('Plus de 100 blocs ! tes-vous sr ?',...
                'Confirmation','Oui','Annuler','Annuler');
            switch answer
            case 'Oui'
            case 'Annuler'
                return
            end
        end
        titre=get(findobj(gcf,'Tag','pagetitle'),'string');
        polaire(donnee,V,profdata,titre);
    case 'sinusoide'
        identificateur=get(gcbo,'Userdata'); 
        % identificateur des lments graphiques
        % associs  l'criture des diagrammes polaires => menu d'appel et 
        % lignes de controle
        % Position de la ligne de dbut et bloc associ
        debline=findobj('Tag','debline','Userdata',identificateur);
        debaxis=get(debline,'Parent');
        debfigure=get(debaxis,'Parent');
        debpoint=get(debline,'Ydata'); debpoint=debpoint(1);
        axnumberdeb=get(debaxis,'UserData');
        blocmin=250*(axnumberdeb-1)+floor(debpoint);
        % Position de la ligne de dbut et bloc associ
        finline=findobj('Type','line',...
            'Tag','finline',...
            'Userdata',identificateur);
        finaxis = get(finline,'Parent');
        finpoint=get(finline,'Ydata');finpoint=finpoint(1);
        axnumberfin=get(finaxis,'UserData');
        blocmax=250*(axnumberfin-1)+ceil(finpoint);
        % identificateur des lments graphiques associs 
        % l'affichage de la diagraphie => figure
        debfigure=get(debaxis,'Parent');
        figdata=getappdata(debfigure,'figdata');
        donnee=getappdata(figdata,'donnee');
        profdata=getappdata(figdata,'profondeur');
        if isappdata(gcbf,'orientation')
            orientation=getappdata(gcbf,'orientation');
        else
            orientation=[];
        end
        V=blocmin:blocmax;
        V=sort(V);
        % Protection des donnes
        if (V(length(V))-V(1))>=100
            answer=questdlg('Plus de 100 blocs ! tes-vous sr ?',...
                'Confirmation','Oui','Annuler','Annuler');
            switch answer
            case 'Oui'
            case 'Annuler'
                return
            end
        end
        titre=get(findobj(gcf,'Tag','pagetitle'),'string');
        if ~isempty(orientation)
            sinusoide(donnee,profdata,[blocmin blocmax],orientation);
        else
            sinusoide(donnee,profdata,[blocmin blocmax]);
        end
    end
end

