% selectbloc
%
%  V=selectbloc(datas)
%		datas : matrice des profondeurs
%		V 		: indices de blocs, tris par ordre croissant
%
% selection de blocs  partir de la visualisation de la profondeur.
% toute similitude avec selectrange.m n'est pas fortuite
%
% PRrequis
%	@ Fichiers associs
% selectbloc.fig
%
% Aide modifie le : 21/12/2000

function V=selectbloc(datas)
if ~ischar(datas)
   pmin=1;
   pmax=length(datas);
   %   open('selectbloc.fig');
   selectprof_fig;
   set(findobj(gcf,'Tag','valdeb'),'Callback','selectbloc(''vmin'')');
   set(findobj(gcf,'Tag','valfin'),'Callback','selectbloc(''vmax'')');
   % Je ne sais pas pourquoi mais 'guide' ne veut pas sauver les 2
   % callbacks prcdents. 
   set(findobj(gcf,'Tag','valmin'),'string',num2str(pmin));
   set(findobj(gcf,'Tag','valdeb'),'string',num2str(pmin));
   set(findobj(gcf,'Tag','valmax'),'string',num2str(pmax));
   set(findobj(gcf,'Tag','valfin'),'string',num2str(pmax));
   plot(datas);
	hold on;
   xlabel('Blocs');set(gca,'Ygrid','on');
   ylabel('Profondeur lue (m)');
   ylim = get(gca,'Ylim');
   linehndl1 = plot(pmin*[1 1],ylim,':',...
		    'EraseMode','xor', ...
		    'ButtonDownFcn', 'selectbloc(''selection'');',...
		    'Color',[1 0 0],...
		    'Tag','debline');
   linehndl2 = plot(pmax*[1 1],ylim,':',...
		    'EraseMode','xor', ...
		    'ButtonDownFcn', 'selectbloc(''selection'');',...
		    'Color',[1 0 0],...
		    'Tag','finline');
   % Points anguleux
   courb=str2num(get(findobj(gcf,'Tag','courbure'),'string'));
   indices=find(abs(del2(datas))>courb);
   userdata.data=datas;
   userdata.indices=indices;
   set(gcf,'Userdata',userdata)
   plot(indices,datas(indices),'go',...
	'Tag','anguleux',...
	'ButtonDownFcn','selectbloc(''anguleux'');');
   uiwait;
   deb=str2num(get(findobj(gcf,'Tag','valdeb'),'string'));
   fin=str2num(get(findobj(gcf,'Tag','valfin'),'string'));
   V=[deb fin];
   V=sort(V);
   close(gcf);
else
  switch datas
      % callback appels par la fonction principale pour des
      % raisons de visibilit des sous-fonctions 
   case 'selection'
     hndl = get(gcf,'CurrentObject');
     set(hndl,'UserData',gca);
     set(hndl,'Visible','off','LineWidth', 5);
     set(hndl,'Visible','on');
     set(gcf,'WindowButtonUpFcn', 'selectbloc(''haut'');', ...
	     'WindowButtonMotionFcn', 'selectbloc(''deplace'');');
   case 'deplace'
     hndl = get(gcf,'CurrentObject');
      %  Get the current cursor point and axis limits
     lineaxis = get(hndl,'Parent');
     point = get(lineaxis,'CurrentPoint');
     xlim  = get(lineaxis,'Xlim');
     ylim  = get(lineaxis,'Ylim');
      %  Update the slider line display
     newpt= min(max(point(1,1),xlim(1)),xlim(2));
     pmax=str2num(get(findobj(gcf,'Tag','valmax'),'string'));
     newpt= min(newpt,pmax); % On fait en sorte de ne pas dpasser le max
     pmin=str2num(get(findobj(gcf,'Tag','valmin'),'string'));
     newpt=max(newpt, pmin); % On fait en sorte de ne pas dpasser le min
     set(hndl, 'Xdata', newpt*[1 1]);
     switch get(hndl,'Tag')
      case 'debline'
       set(findobj(gcf,'Tag','valdeb'),'String',num2str(ceil(newpt)));
      case 'finline'
       set(findobj(gcf,'Tag','valfin'),'String',num2str(floor(newpt)));
     end
   case 'haut'
      %  Change the line slider width and set the appropriate
      %  window properties.
      hndl = get(gcf,'CurrentObject');
      axishndl = get(hndl,'UserData');
      set(gcf, 'WindowButtonUpFcn','', 'WindowButtonMotionFcn','');
      set(hndl,'Visible','off');
      set(hndl, 'LineWidth', 1,...
		'ButtonDownFcn', 'selectbloc(''selection'');');
      set(hndl,'Visible','on');
   case 'vmin'
      pmin=str2num(get(findobj(gcbf,'Tag','valmin'),'string'));
      pmax=str2num(get(findobj(gcbf,'Tag','valmax'),'string'));
      val=ceil(str2num(get(gcbo,'String')));
      val=min(max(val, pmin),pmax);
      set(gcbo,'string',num2str(val));
      set(findobj(gcbf,'Tag','debline'),'Xdata',val*[1 1]);
   case 'vmax'
      pmin=str2num(get(findobj(gcbf,'Tag','valmin'),'string'));
      pmax=str2num(get(findobj(gcbf,'Tag','valmax'),'string'));
      val=floor(str2num(get(gcbo,'String')));
      val=min(max(val,pmin),pmax);
      set(gcbo,'string',num2str(val));
      set(findobj(gcbf,'Tag','finline'),'Xdata',val*[1 1]);
   case 'anguleux'
      hndl = get(gcbf,'CurrentObject');
      %  Get the current cursor point and axis limits
      lineaxis = get(hndl,'Parent');
      point = get(lineaxis,'CurrentPoint');
      ylim  = get(lineaxis,'Ylim');
      string=str2mat('haut','bas','annuler');
      position=get(gcbf,'CurrentPoint');
      set(findobj(gcbf,'Tag','lineselect'),'value',3,'userdata',1);
      h=uicontrol('style','Popupmenu',...
		  'string',string,...
		  'Callback','set(gcbo,''userdata'',1)'...
		  ,'Tag','lineselect',...
		  'Position',[position 90 10],...
		  'BackgroundColor',[1 1 1]);
      waitfor(h,'userdata');
      issue=get(h,'value')
      delete(h);
      newpt= min(max(point(1,1),xlim(1)),xlim(2));
      % Selection du point notable l'indice le plus propre.
      userdata=get(gcbf,'Userdata');
      datas=userdata.data;
      indices=userdata.indices;
      [mind,ind]=min(abs(datas(indices)-newpt));
      nouveau=datas(indices(ind));
      xinf=max(get(findobj(gcbf,'Tag','debline'),'Xdata'));
      xsup=min(get(findobj(gcbf,'Tag','finline'),'Xdata'));
      if nouveau<=xinf
	set(findobj(gcbf,'Tag','debline'),'Xdata',nouveau*[1 1]);
	set(findobj(gcbf,'Tag','valdeb'),'string',num2str(nouveau));
      elseif nouveau>=xsup;
         set(findobj(gcbf,'Tag','finline'),'Xdata',nouveau*[1 1]);
         set(findobj(gcbf,'Tag','valfin'),'string',num2str(nouveau));
      else
	switch issue 
         case 1
            set(findobj(gcbf,'Tag','finline'),'Xdata',nouveau*[1 1]);
            set(findobj(gcbf,'Tag','valfin'),'string',num2str(nouveau));
         case 2   
            set(findobj(gcbf,'Tag','debline'),'Xdata',nouveau*[1 1]);
            set(findobj(gcbf,'Tag','valdeb'),'string',num2str(nouveau));
         case 3
            % ne fait rien
         end
      end
   case 'courbure'
      delete(findobj(gcbf,'Tag','anguleux','Type','line'));
      courb=str2num(get(gcbo,'string'))
      userdata=get(gcbf,'Userdata');
      datas=userdata.data;
      indices=find(abs(del2(datas))>courb);  size(indices)    
      userdata.indices=indices;
      set(gcbf,'Userdata',userdata);
      plot(indices,datas(indices),'go',...
	   'Tag','anguleux',...
	   'ButtonDownFcn','selectbloc(''anguleux'');');
   end
end


   